package org.artifactory.probes.service;

/**
 * @author Andrey Tashlitsky
 */
public interface ProbesService {

    /**
     * Triggers all the readiness related checks.
     */
    void triggerReadinessCheck();

    /**
     * Checks the readiness probe status.
     *
     * @param noCache Do not return cached status.
     */
    void checkReadinessStatus(boolean noCache);

    /**
     * Checks the liveness probe status.
     */
    void checkLivenessStatus();
}
