package org.artifactory.security.permissionscope;

import lombok.experimental.UtilityClass;
import org.jfrog.access.common.PermissionScope;
import org.jfrog.access.common.PermissionScopeAction;
import org.jfrog.access.common.PermissionScopeResourceType;

@UtilityClass
public class PermissionScopeToken {

    public static String SUPPORT_BUNDLE_SCOPE_TARGET = "supportbundle";

    public static final PermissionScope INTERNAL_SUPPORT_BUNDLE_READ =
            PermissionScope.create(PermissionScopeResourceType.INTERNAL, SUPPORT_BUNDLE_SCOPE_TARGET,
                    PermissionScopeAction.READ);
    public static final PermissionScope INTERNAL_SUPPORT_BUNDLE_WRITE =
            PermissionScope.create(PermissionScopeResourceType.INTERNAL, SUPPORT_BUNDLE_SCOPE_TARGET,
                    PermissionScopeAction.WRITE);
    public static final PermissionScope INTERNAL_SUPPORT_BUNDLE_DELETE =
            PermissionScope.create(PermissionScopeResourceType.INTERNAL, SUPPORT_BUNDLE_SCOPE_TARGET,
                    PermissionScopeAction.DELETE);
}
