package org.artifactory.servicetrust;

import org.apache.commons.lang.NotImplementedException;
import org.artifactory.descriptor.authentication.AuthenticationToken;
import org.jfrog.access.token.JwtAccessToken;

import java.util.Collection;

/**
 * @author igoru
 */
public interface TokenSpecOutboundService {

    /**
     * Store master token together with exchange url, base url and other
     */
    void storeMasterTokenData(ExchangeTokenResponse response, TokenExtension extension);

    /**
     * Update master token to avoid expiration
     */
    void updateMasterTokenData(ExchangeTokenResponse response);

    ExchangeTokenRequest createExchangeTokenRequest(String subject, JwtAccessToken jwt);

    /**
     * Create exchange token to refresh master token
     */
    ExchangeTokenRequest createMasterTokenExchangeRefreshRequest(String subject);

    ExchangeTokenRequest createScopedTokenExchangeRequest(String subject, String... scopes);

    default Collection<AuthenticationToken> getPairedInstances() {
        throw new NotImplementedException();
    }
}
