package org.artifactory.queue;

import org.artifactory.event.queue.QueueCursorType;
import org.artifactory.event.queue.QueueReductionBehaviours;
import org.artifactory.queue.behaviors.QueueReductionBehavioursImpl;
import org.artifactory.storage.db.event.entity.enums.NodeEventCursorType;
import org.testng.Assert;
import org.testng.annotations.Test;

@Test
public class QueueEnumsMappingValidation {

    @Test
    public void testQueueCursorType() {
        for (QueueCursorType queueCursorType : QueueCursorType.values()) {
            NodeEventCursorType nodeEventCursorType = QueueCursorTypeMapper.get(queueCursorType);
            Assert.assertNotNull(nodeEventCursorType);
            Assert.assertTrue(nodeEventCursorType.isEventIdType());
        }
    }

    @Test
    public void testQueueReductionBehaviours() {
        for (QueueReductionBehaviours queueReductionBehaviours : QueueReductionBehaviours.values()) {
            QueueReductionBehavioursImpl queueReductionBehavioursImpl =
                    QueueReductionBehavioursImpl.get(queueReductionBehaviours);
            Assert.assertNotNull(queueReductionBehavioursImpl);
        }
    }

}
