package org.artifactory.schedule;

import java.util.Arrays;

public enum JobName {
    ANY("any"),
    ARCHIVE_INDEX("archive-index"),
    ARTIFACT_CLEANUP("artifact-cleanup"),
    ARTIFACT_DISTRIBUTION_STATUS("artifact-distribution-status"),
    BACKUP("backup"),
    BINARY_STORE_ERROR_NOTIFICATION("binary-store-error-notification"),
    BINARY_STORE_GARBAGE_COLLECTOR("binary-store-garbage-collector"),
    BINARY_STORE_TRASH_CLEANUP_GC("binary-store-trash-cleanup-gc"),
    BUILD_INFO_MIGRATION("build-info-migration"),
    CALL_HOME("call-home"),
    CONAN_V2_MIGRATION("conan-v2-migration"),
    CREDENTIALS_WATCH("credentials-watch"),
    DELETE_EXPIRED_SESSIONS("delete-expired-sessions"),
    DOCKER_V2_TAG_CLEANUP("docker-v2-tag-cleanup"),
    DOCKER_TAG_ORPHAN_LAYER_CLEANUP("docker-tag-orphan-layer-cleanup"),
    DUMMY("dummy"),
    EXPORT("export"),
    FOLDER_PRUNING("folder-pruning"),
    HEARTBEAT("heartbeat"),
    IMPORT("import"),
    INBOUND_REPLICATION_CHANNEL("inbound-replication-channel"),
    INIT_QUEUES_CONTEXT("init-queues-context"),
    INTEGRATION_CLEANUP("integration-cleanup"),
    JOB_TABLE_CLEANUP("job-table-cleanup"),
    MAVEN_INDEXER("maven-indexer"),
    PASSWORD_EXPIRE_NOTIFICATION("password-expire-notification"),
    PLUGIN_COMMAND("plugin-command"),
    PUSH_REPLICATION("push-replication"),
    RETENTION_ARCHIVE("artifact-retention-archive"),
    RETENTION_PULL_RESTORED_ITEMS("artifact-retention-pull-restored-items"),
    RETENTION_MAP_RESTORE_STATUS("artifact-retention-map-restore-status"),
    RETENTION_CLEANUP("artifact-retention-expired-artifacts-cleanup"),
    RETENTION_REFRESH_MASTER_TOKEN("artifact-retention-refresh-master-token"),
    REFRESHABLE_SCHEDULED("refreshable-scheduled"),
    RELEASE_BUNDLE_CLEANUP("release-bundle-cleanup"),
    RELEASE_EXPIRED_LOCKS("release-expired-locks"),
    REMOTE_REPLICATION("remote-replication"),
    REPO_PATH_CHECKSUM_MIGRATION("repo-path-checksum-migration"),
    SHA_256_MIGRATION("sha-256-migration"),
    STATS_DELEGATING_SERVICE_FLUSH("stats-delegating-service-flush"),
    STATS_PERSISTING_SERVICE_FLUSH("stats-persisting-service-flush"),
    UPDATE_INDICES("update-indices"),
    CUSTOMER_UPDATES("customer-updates"),
    VIRTUAL_CACHE_CLEANUP("virtual-cache-cleanup"),
    WORK_QUEUE("work-queue"),
    PERSISTENT_QUEUE("persistent-queue"),
    XRAY_INDEX_EVENT("xray-index-event"),
    XRAY_PROPS_CLEANUP("xray-props-cleanup"),
    DOCKER_UPLOADS_FOLDER_CLEANUP("docker-uploads-folder-cleanup"),
    EVENT_LOG_CLEANUP("event-log-cleanup"),
    STORAGE_SUMMARY_CALCULATOR("storage-summary-calculator"),
    STORAGE_USAGE_SYNC("storage-usage-sync"),
    COLD_STORAGE_CONSUMPTION_LOGGING("cold-storage-consumption-logging"),
    EVENTUALLY_PERSISTED_TASK_MANAGER("eventually-persisted-task-manager"),
    FEDERATED_REPO_DELETED_CONFIG_CLEANUP("federated-repo-deleted-config-cleanup"),
    FEDERATED_LAZY_TEMP_DIR_CLEANUP("federated-lazy-temp-dir-cleanup"),
    FEDERATE_FULLSYNC_TASK("federated-fullsync-task"),
    AIR_GAP_EXPORT("airgap-export"),
    AIR_GAP_RECOVERY("airgap-recovery"),
    UPDATE_STORAGE_METRIC("update-storage-metric"),
    PROJECT_STORAGE_QUOTA_NOTIFICATION("project-storage-quota-notification"),
    SYNC_REPOSITORIES_WITH_ACCESS("sync-repositories-with-access"),
    EXTEND_LICENSE_CONSUMPTION("extend-license-consumption"),
    READINESS("readiness"),
    MIRROR_HEARTBEAT("mirror-heartbeat"),
    TEMP_MIRROR_HEARTBEAT("temp-mirror-heartbeat"),
    // For itests only
    TEST_JOB1("job1"),
    TEST_JOB2("job2"),
    TEST_JOB3("job3"),
    TEST_JOB4("job4"),
    LONG_RUNNING_JOB("long-running-job");

    private String text;

    JobName(String text) {
        this.text = text;
    }

    static JobName of(String fieldName) {
        return Arrays.stream(values())
                .filter(value -> value.text.equals(fieldName))
                .findFirst()
                .orElse(null);
    }

    public String asText() {
        return text;
    }
}
