package org.artifactory.workqueue;

import lombok.EqualsAndHashCode;
import lombok.Getter;

import javax.annotation.Nonnull;

import static com.google.common.base.Preconditions.checkArgument;

@EqualsAndHashCode(of = {"name"})
@Getter
public class WorkQueueInfo {
    private final int maxNumberOfThreads;
    private final String name;
    private final WorkQueueConflictsGuardProvider conflictsGuardProvider;

    public WorkQueueInfo(int maxNumberOfThreads, @Nonnull String name,
            @Nonnull WorkQueueConflictsGuardProvider conflictsGuardProvider) {
        checkArgument(name != null, "Invalid name");
        checkArgument(conflictsGuardProvider != null, "Invalid conflictsGuardProvider");
        this.maxNumberOfThreads = maxNumberOfThreads;
        this.name = name;
        this.conflictsGuardProvider = conflictsGuardProvider;
    }
}
