package org.artifactory.rest.common.exception.mapper;

import org.artifactory.core.api.ph.exception.PackageException;
import org.artifactory.rest.ErrorResponse;
import org.springframework.stereotype.Component;

import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.ext.ExceptionMapper;
import javax.ws.rs.ext.Provider;

@Component
@Provider
public class PackageExceptionMapper implements ExceptionMapper<PackageException> {

    @Override
    public Response toResponse(PackageException exception) {
        ErrorResponse errorResponse = new ErrorResponse(exception.getStatus(), exception.getPublicReason());
        return Response.status(exception.getStatus()).type(MediaType.APPLICATION_JSON).entity(errorResponse).build();
    }
}
