package org.artifactory.ui.rest.model.admin.configuration.repository.info;

import org.artifactory.api.config.CentralConfigService;
import org.artifactory.common.repo.RepoType;
import org.artifactory.descriptor.replication.ReplicationBaseDescriptor;
import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.ph.PackageSpecification;

public class FederatedRepositoryInfo extends RepositoryInfo {

    private Boolean replications;

    public FederatedRepositoryInfo() {
    }

    public FederatedRepositoryInfo(FederatedRepoDescriptor repoDescriptor, CentralConfigService configService,
            PackageSpecification packageSpecification) {
        repoKey = repoDescriptor.getKey();
        repoType = repoDescriptor.getType().toString();
        // checks if there is at least one enabled replication
        replications = (configService.getDescriptor().getMultiLocalReplications(repoKey).stream()
                .anyMatch(ReplicationBaseDescriptor::isEnabled));
        hasReindexAction = packageSpecification.hasReindex(RepoType.LOCAL, repoDescriptor.getType());
    }

    public Boolean getReplications() {
        return replications;
    }

    public void setReplications(Boolean replications) {
        this.replications = replications;
    }
}
