package org.artifactory.ui.rest.service.admin.configuration.repositories.util;

import com.google.common.collect.Maps;
import org.artifactory.api.config.CentralConfigService;
import org.artifactory.descriptor.config.CentralConfigDescriptor;
import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.descriptor.repo.LocalRepoDescriptor;
import org.testng.Assert;
import org.testng.annotations.Test;

import java.util.Map;

import static org.artifactory.ui.rest.service.admin.configuration.repositories.util.CreateDefaultJcenterRepoService.DEFAULT_JCENTER_NAME;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;

/**
 * @author Alexei Vainshtein
 */
public class CreateDefaultJcenterRepoServiceTest {

    @Test
    public void testGuessNameForJcenter() {
        CentralConfigService configService = mock(CentralConfigService.class);
        CentralConfigDescriptor configDescriptor = mock(CentralConfigDescriptor.class);
        when(configService.getDescriptor()).thenReturn(configDescriptor);
        Map<String, LocalRepoDescriptor> reposMap = Maps.newLinkedHashMap();
        reposMap.put(DEFAULT_JCENTER_NAME, new FederatedRepoDescriptor());
        when(configDescriptor.getLocalAndFederatedRepositoriesMap()).thenReturn(reposMap);
        CreateDefaultJcenterRepoService repoService = new CreateDefaultJcenterRepoService(configService, null);
        Assert.assertEquals(repoService.guessNameForJcenter(), DEFAULT_JCENTER_NAME + "-default");
    }
}